#include "defines.h"

#define DEFPORT	"/dev/refclock-0"

struct termios	oldmodes;
struct termios	newmodes;

int 		erg = 0, fd = 0, line = 0, set=0;
char 		buf[100];
char 		data[60];
struct tm	ts;


/* Drucke den Inhalt des Puffers binaer aus... */
void print_buf(int erg)	
{
	int i;
	for (i=0; i<erg; i++) {
		printf("%d \t %s\n", buf[i]==0 ? 0:1 , dez2bin(buf[i]));
	}
}


/* warte mittels SELECT auf Daten */
void readdata(int fd)
{
	fd_set		rds;
	struct timeval	tv;
	int 		ret, erg=0,i=0;
	int 		frame_start=0;
	char		c[1];

	newmodes.c_cc[VMIN]  = 1;
	newmodes.c_cc[VTIME] = 0;	
	ioctl(fd, TCSETS, &newmodes);

	FD_ZERO(&rds);
	FD_SET(fd, &rds);

	tv.tv_sec  = 1;
	tv.tv_usec = 400;
	
	while (1) {
		ret = select(fd + 1, &rds, NULL, NULL, &tv);
		switch (ret) {
			case 0: 
			{
				printf(" Time-Gap\n");
				FD_SET(fd, &rds);
				i = 0; frame_start = 1;
			}
			default:
			{ 
				erg = read(fd, c, 1);
				if ((frame_start)&&(erg)) {
					data[i] = (*c==0 ? 1:0);
					printf("%d", data[i]);
					fflush(stdout);
				}
				else {
					printf("#");
					fflush(stdout);
				}
				i++;
				break;
			}
		}
		tv.tv_sec  = 1;
		tv.tv_usec  = 400;
		if ((i >= 59)&&(frame_start)) break;
	}
	printf("\n\r");

	if (CheckDCF(data)) {
		ts = ParseDCF(data);
		set &= ~(getuid());
	
		if (set) syslog(LOG_NOTICE, "%s\n",time2str(&ts,set));
	} else
		syslog(LOG_NOTICE, "Bad Frame; time not set\n");
}


/* Initialisiere die Leitung (serielle Schnittstelle) */
void openport(int line)	
{
	ioctl(fd, TCGETS, &oldmodes);	/* Get old modes to save later */
	ioctl(fd, TCGETS, &newmodes);	/* Get old modes to change them */

	newmodes.c_cflag  =  0;
	newmodes.c_cflag |=   (B50 | CS7 | CLOCAL | CREAD);

	newmodes.c_iflag  =  0;

	newmodes.c_lflag  =  0;

	newmodes.c_cc[VMIN]  = 1;
	newmodes.c_cc[VTIME] = 0;	

	ioctl(fd, TCSETS, &newmodes); 	/* Set  new  modes	*/


	ioctl(fd, TIOCMGET, &line);	
	  line &= ~TIOCM_DTR;		/* switch DTR off	*/
	  line |=  TIOCM_RTS; 		/*   "    RTS on	*/
	ioctl(fd, TIOCMSET, &line);
}


/* Leitung wieder in Originalzustand bringen */
void closeport()
{ 
	erg = ioctl(fd,TCGETS, &oldmodes);
	close (fd);
}


/* Hauptprogramm... */
void main(int argc, char **argv)
{
	int 	o=0;
	char	port[] = DEFPORT;

	openlog("dcf77", LOG_PID, LOG_DAEMON);

	while ((o=getopt(argc, argv, "d:s"))!=-1) 
	switch (o) {
	case 'd':
		strcpy(port,optarg);
		break;
	case 's':
		set = 1;
	}


	fd = open(DEFPORT,O_RDONLY);
	if (fd<1) { 
		perror(argv[0]);
		exit(1);
	}

	openport(fd);
	printf("Port %s geffnet...\n", DEFPORT);

	readdata(fd);

	closeport();
}
